<?php

require 'core/egais.php';

class egais_utm1 extends Egais {


	protected function _utmSendFile($url, $content) {
		$eol = "\r\n";
		$data = '';
		
		$content = "\xef\xbb\xbf" . $content;
		 
		$mime_boundary=md5(time());
		 
		$data .= '--' . $mime_boundary . $eol;
		$data .= 'Content-Disposition: form-data; name="xml_file"; filename="check.xml"' . $eol;
		$data .= 'Content-Type: text/plain' . $eol;
		$data .= 'Content-Transfer-Encoding: base64' . $eol . $eol;
		$data .= base64_encode($content) . $eol;
		$data .= "--" . $mime_boundary . "--" . $eol . $eol; // finish with two eol's!!
		 
		$params = array('http' => array(
						  'method' => 'POST',
						  'header' => 'Content-Type: multipart/form-data; boundary=' . $mime_boundary . $eol,
						  'timeout' => 10, //in seconds
						  'content' => $data
					   ));
		 
		$ctx = stream_context_create($params);
		$response = @file_get_contents($url, false, $ctx);
		
		return $response;
	}

	protected function _check($addr, $port) {
		$fp = fsockopen($addr, $port, $errno, $errstr, 7);
		if (!$fp) return false;
		fclose($fp);
		return true;
	}

	public function SendXml($params) {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$xml = $params['xml'];

		$utmIp = explode(':', $_REQUEST['utmip']);
		$port = (sizeof($utmIp) > 1) ? $utmIp[1] : '8080';
		$utmIp = $utmIp[0];

		if (! $this->_check($utmIp, $port) ) {
			return array('success'=>false, 'errcode' => 'UTM_NETWORK_ERROR', 'error' => 'Модуль УТМ недоступен. Проверьте подключение');
		}

		$url = 'http://' . $utmIp . ':' . $port . '/xml';
		$utmResult = $this->_utmSendFile($url, $xml);
		
		if (!$utmResult) {
			return array('success'=>false, 'errcode' => 'UTM_ERROR', 'error' => 'Модуль УТМ вернул ошибку');
		}
		
		return array('success'=>true, 'utm' => $utmResult);
		$this->log(__METHOD__ . " ----- end OK\n", 3);
		
	}

}
